#include "DebugLog.h"
DebugLog Log(DEBUG_LOG);

#include <stdarg.h>
#include <time.h>

DebugLog::DebugLog(const char *file)
{
   File = file;
   hFile = NULL;

	New();
}

void DebugLog::New()
{
	hFile = fopen(File, "wt");
   fprintf(hFile, "==== Debug Log File ==== \n\n");

   time_t ltime;
   time(&ltime);

	fprintf(hFile, "%s\n\n", ctime(&ltime));   // Include date and time

   fclose(hFile);
}

void __cdecl DebugLog::printf(const char *Format, ...)
{
	char Buffer[256];
   va_list ArgList;

   va_start(ArgList, Format);
   _vsnprintf(Buffer, 256, Format, ArgList);
   va_end(ArgList);

   hFile = fopen(File, "at");
   fprintf(hFile, Buffer);
   fclose(hFile);
}

DebugLog &DebugLog::operator<<(char ch)
{
	printf("%c", ch);

	return *this;
}

DebugLog &DebugLog::operator<<(unsigned char uch)
{
	printf("%c", uch);

	return *this;
}

DebugLog &DebugLog::operator<<(signed char sch)
{
	printf("%c", sch);

	return *this;
}

DebugLog &DebugLog::operator<<(const char* psz)
{
	printf(psz);

	return *this;
}

DebugLog &DebugLog::operator<<(const unsigned char* pusz)
{
	printf((const char*)pusz);

	return *this;
}

DebugLog &DebugLog::operator<<(const signed char* pssz)
{
	printf((const char*)pssz);

	return *this;
}

DebugLog &DebugLog::operator<<(short s)
{
	printf("%hi", s);

	return *this;
}

DebugLog &DebugLog::operator<<(unsigned short us)
{
	printf("%hu", us);

	return *this;
}

DebugLog &DebugLog::operator<<(int n)
{
	printf("%i", n);

	return *this;
}

DebugLog &DebugLog::operator<<(unsigned int un)
{
	printf("%u", un);

	return *this;
}

DebugLog &DebugLog::operator<<(long l)
{
	printf("%li", l);

	return *this;
}

DebugLog &DebugLog::operator<<(unsigned long ul)
{
	printf("%lu", ul);	

	return *this;
}

DebugLog &DebugLog::operator<<(float f)
{
	printf("%g", f);

	return *this;
}

DebugLog &DebugLog::operator<<(double d)
{
	printf("%g", d);

	return *this;
}

DebugLog &DebugLog::operator<<(long double ld)
{
	printf("%g", ld);

	return *this;
}

DebugLog &DebugLog::operator<<(const void* pv)
{
	printf("%p", pv);

	return *this;
}
